/*
	[ZE] Nemesis Round v1.0.0
	- Plugin : Jack Gameplay 
	- Edit : LiZou Mapper
	
	[ZE] Special Thanks : 
	- Thanks special for Kaya Gaming for codes 
	- That i help me in codding  

			<Escapers-Zone.net>
	
*/
// Included
#include <zombie_escape>
#include <fun>
#include <cstrike>

// Variable Bool
new bool:g_bNemesis[33]
 
// Natives
native give_longjump(id) 
 
// Cvar Variables
new _Cvar_Health_Nemesis 
new _Cvar_Gravity_Nemesis 
new _Cvar_Speed_Nemesis
new _Cvar_Glow_Nemesis
new _Cvar_Longjump

// Default Models
new const model_nemesis_player[] = { "models/player/ze_nemesis_host/ze_nemesis_host.mdl" }
new const model_nemesis_knife[] = { "models/zombie_escape/v_knife_nemesis.mdl" }

// Default Sounds
new const sound_nemesis_notice[] = { "zombie_escape/ze_nemesis.wav" }

public plugin_init(){
    register_plugin("[ZE] First Round Nemesis !!!", "1.0", ">Jack | LiZou<");
    
    // Cvars
    _Cvar_Health_Nemesis = register_cvar("ze_health_nemesis", "30000");
    _Cvar_Gravity_Nemesis = register_cvar("ze_gravity_nemesis", "650");
    _Cvar_Speed_Nemesis = register_cvar("ze_speed_nemesis", "330");
    _Cvar_Glow_Nemesis = register_cvar("ze_glow_nemesis", "1")
    _Cvar_Longjump = register_cvar("ze_nemesis_longjump", "1");
    
}

public plugin_precache()
{
	// Precache Model
	precache_model( model_nemesis_player )
	precache_model( model_nemesis_knife )
	// Precache Sound 
	precache_sound( sound_nemesis_notice )
}

public client_disconnected(id)
{
	g_bNemesis[id] = false
}
 
public ze_zombie_appear()
{
    new iPlayers[32], iSelected[33], iTotalPlayers, id, iCount, iRandomIndex
    get_players(iPlayers, iTotalPlayers)
 
    if (iTotalPlayers > 0)
    {
        for (id = 0; id <= iTotalPlayers; id++)
        {
            iRandomIndex = iPlayers[id]
 
            if (!is_user_alive(id) || !ze_is_user_zombie(id))
                continue
 
            iSelected[iCount] = iRandomIndex
            iCount++
        }
    }
    
    ze_feature_nemesis(id)
    
    iRandomIndex = iSelected[random(iCount)]
    g_bNemesis[iRandomIndex] = true  
}

// Feature Nemesis
public ze_feature_nemesis(id)
{

	// Health Nemesis  
	set_user_health(id, _Cvar_Health_Nemesis)
	
	// Gravity Nemesis  
	set_user_gravity(id, _Cvar_Gravity_Nemesis)
	
	// Speed Nemesis
	fm_set_user_speed(id, _Cvar_Speed_Nemesis)
	
	// Nemesis Glow
	if(get_pcvar_num(_Cvar_Glow_Nemesis))
		set_user_rendering(id, kRenderFxGlowShell, 255, 0, 0, kRenderNormal, 25)	
		
	// Model Nemesis
	if(is_user_alive(id) && is_user_connected(id))
	{
		cs_set_user_model(id, model_nemesis_player)
	}
	
	// Claw Nemesis
	if(get_user_weapon(id) == CSW_KNIFE && ze_is_user_zombie(id))
	{
		rg_give_item(id, "weapon_knife")
		set_pev(id, pev_viewmodel2, model_nemesis_knife)
		set_pev(id, pev_weaponmodel2, "")
	}
	
	// Long Jump
	if(_Cvar_Longjump == 1)
	{
		give_longjump(id)
	}	
}
 
public ze_user_infected_pre(iVictim, iInfector, iDamage)
{
	new id
	user_silentkill(id)
	return 1;
}

/*
public kill_no_infect(id)
{
	// Stop Register Score Kill in ScoreBoard
	user_silentkill(id)
}
*/
	 
public notice_nemesis(id)
{
	// Show Hud Message Nemesis Round !
	set_hudmessage(255, 0, 0, -1.0, -1.0, 2, 6, 5, 0.1, 1.5)
	show_hudmessage(id, "<!Nemesis Round!>")
	
	// Play Sound Notice Nemesis
	client_cmd(id ,"spk %s", sound_nemesis_notice)		
}
 
public ze_roundend(id)
{
	for (new id = 0; id <= get_member_game(m_nMaxPlayers); id++)
	{
		if (!is_user_alive(id) || !ze_is_user_zombie(id))
			continue
 
		g_bNemesis[id] = false
	}
    
	// Remove Nemesis Glow
	if(get_pcvar_num(_Cvar_Glow_Nemesis))
		set_user_rendering(id)
}

// Stock 
stock fm_set_user_speed(id, Float:Speed)
{
	set_pev(id, pev_maxspeed, Speed)
}
	
